diff --git a/reactos/base/setup/usetup/lang/eo-AA.h b/reactos/base/setup/usetup/lang/eo-AA.h
index 3b72dcf..b4711e7 100644
--- a/reactos/base/setup/usetup/lang/eo-AA.h
+++ b/reactos/base/setup/usetup/lang/eo-AA.h
@@ -2,7 +2,6 @@
 
 MUI_LAYOUTS eoAALayouts[] =
 {
-    { L"048F", L"00020409" },
-    { L"0409", L"00000409" },
+    { L"048F", L"0000048F" },
     { NULL, NULL }
 };
diff --git a/reactos/base/setup/usetup/muilanguages.h b/reactos/base/setup/usetup/muilanguages.h
index e0e1757..fbee591 100644
--- a/reactos/base/setup/usetup/muilanguages.h
+++ b/reactos/base/setup/usetup/muilanguages.h
@@ -571,7 +571,7 @@ const MUI_LANGUAGE LanguageList[] =
     {L"00003409", L"1252", L"437", L"10000", L"English (Philippines)", L"201", enUSPages, enUSErrorEntries, enUSStrings, LatinFonts, enPHLayouts },
 #endif
 #ifdef LANGUAGE_EO_AA
-    {L"0000048F", L"1252", L"437", L"10000", L"Esperanto", L"1", enUSPages, enUSErrorEntries, enUSStrings, LatinFonts, eoAALayouts },
+    {L"0000048F", L"28593", L"437", L"10000", L"Esperanto", L"1", enUSPages, enUSErrorEntries, enUSStrings, LatinFonts, eoAALayouts },
 #endif
 #ifdef LANGUAGE_ET_EE
     {L"00000425", L"1252", L"775", L"10029", L"Estonian", L"70", etEEPages, etEEErrorEntries, etEEStrings, LatinFonts, etEELayouts },
diff --git a/reactos/boot/bootdata/hivesys.inf b/reactos/boot/bootdata/hivesys.inf
index d5f03ac..82e74ef 100644
--- a/reactos/boot/bootdata/hivesys.inf
+++ b/reactos/boot/bootdata/hivesys.inf
@@ -741,6 +741,10 @@ HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000412","Layout Text",
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000412","Layout Display Name",0x00000000,"@%SystemRoot%\system32\input.dll,-5063"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\00000412","Layout Id",0x00000000,"0001"
 
+HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\0000048f","Layout File",0x00000000,"kbdeo.dll"
+HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\0000048f","Layout Text",0x00000000,"Esperanto"
+HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layouts\0000048f","Layout Display Name",0x00000000,"@%SystemRoot%\system32\input.dll,-5142"
+
 ; Keyboard layouts
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout",,0x00000012
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000402",2,"bg"
@@ -775,6 +779,7 @@ HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000424",
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000425",2,"et"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000426",2,"us"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000427",2,"us"
+HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","0000048f",2,"eo"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000804",2,"ch"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000807",2,"sg"
 HKLM,"SYSTEM\CurrentControlSet\Control\Keyboard Layout\DosKeybCodes","00000809",2,"uk"
diff --git a/reactos/boot/bootdata/txtsetup.sif b/reactos/boot/bootdata/txtsetup.sif
index 1d44b24..fd551e2 100644
--- a/reactos/boot/bootdata/txtsetup.sif
+++ b/reactos/boot/bootdata/txtsetup.sif
@@ -380,6 +380,7 @@ Default = "XT-, AT- or extended keyboard (83-105 keys)"
 00000809 = "English (United Kingdom)"
 00000409 = "English (USA)"
 00010409 = "English (USA-Dvorak)"
+0000048F = "Esperanto"
 00000425 = "Estonian"
 0000040B = "Finnish"
 0000080C = "French (Belgium)"
@@ -518,6 +519,7 @@ Default = "XT-, AT- or extended keyboard (83-105 keys)"
 0000044C = kbdinmal.dll
 0000044D = kbdinasa.dll
 00000455 = kbdbur.dll
+0000048F = kbdeo.dll
 
 [HiveInfs.Install]
 AddReg=registry.inf,AddReg
diff --git a/reactos/dll/cpl/input/lang/bg-BG.rc b/reactos/dll/cpl/input/lang/bg-BG.rc
index fa8ac2b..d008c87 100644
--- a/reactos/dll/cpl/input/lang/bg-BG.rc
+++ b/reactos/dll/cpl/input/lang/bg-BG.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Dutch"
+    IDS_ESPERANTO_LAYOUT "Есперанто"
     IDS_ESTONIAN_LAYOUT "Estonian"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/cs-CZ.rc b/reactos/dll/cpl/input/lang/cs-CZ.rc
index 70e4c89..0bc501d 100644
--- a/reactos/dll/cpl/input/lang/cs-CZ.rc
+++ b/reactos/dll/cpl/input/lang/cs-CZ.rc
@@ -165,6 +165,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehština (Fonetická)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehština (Psací stroj)"
     IDS_DUTCH_LAYOUT "Holandština"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estonština"
     IDS_FAEROESE_LAYOUT "Faerština"
     IDS_FARSI_LAYOUT "Fársí"
diff --git a/reactos/dll/cpl/input/lang/de-DE.rc b/reactos/dll/cpl/input/lang/de-DE.rc
index ac5cc1a..9269ac8 100644
--- a/reactos/dll/cpl/input/lang/de-DE.rc
+++ b/reactos/dll/cpl/input/lang/de-DE.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi (Phonetisch)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi (Schreibmaschine)"
     IDS_DUTCH_LAYOUT "Niederländisch"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estnisch"
     IDS_FAEROESE_LAYOUT "Färöisch"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/el-GR.rc b/reactos/dll/cpl/input/lang/el-GR.rc
index a4f8c9c..911549d 100644
--- a/reactos/dll/cpl/input/lang/el-GR.rc
+++ b/reactos/dll/cpl/input/lang/el-GR.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Dutch"
+    IDS_ESPERANTO_LAYOUT "Εσπεράντο"
     IDS_ESTONIAN_LAYOUT "Εσθονικά"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/en-US.rc b/reactos/dll/cpl/input/lang/en-US.rc
index 9009057..b8797a4 100644
--- a/reactos/dll/cpl/input/lang/en-US.rc
+++ b/reactos/dll/cpl/input/lang/en-US.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Dutch"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estonian"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/es-ES.rc b/reactos/dll/cpl/input/lang/es-ES.rc
index b88f7ae..16dff1f 100644
--- a/reactos/dll/cpl/input/lang/es-ES.rc
+++ b/reactos/dll/cpl/input/lang/es-ES.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi (fonético)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi (Máq. de escribir)"
     IDS_DUTCH_LAYOUT "Holandés"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estonio"
     IDS_FAEROESE_LAYOUT "Faroés"
     IDS_FARSI_LAYOUT "Farsí"
diff --git a/reactos/dll/cpl/input/lang/fr-FR.rc b/reactos/dll/cpl/input/lang/fr-FR.rc
index 20a4b29..91658bb 100644
--- a/reactos/dll/cpl/input/lang/fr-FR.rc
+++ b/reactos/dll/cpl/input/lang/fr-FR.rc
@@ -161,6 +161,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonétique"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Néérlandais"
+    IDS_ESPERANTO_LAYOUT "Espéranto"
     IDS_ESTONIAN_LAYOUT "Estonien"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/he-IL.rc b/reactos/dll/cpl/input/lang/he-IL.rc
index 79fc0b5..7f6efd2 100644
--- a/reactos/dll/cpl/input/lang/he-IL.rc
+++ b/reactos/dll/cpl/input/lang/he-IL.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "הולנדית"
+    IDS_ESPERANTO_LAYOUT "אספרנטו"
     IDS_ESTONIAN_LAYOUT "אסטונית"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "פרסית"
diff --git a/reactos/dll/cpl/input/lang/it-IT.rc b/reactos/dll/cpl/input/lang/it-IT.rc
index b0cd2c8..5458966 100644
--- a/reactos/dll/cpl/input/lang/it-IT.rc
+++ b/reactos/dll/cpl/input/lang/it-IT.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi fonetica"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Olandese"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estone"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/no-NO.rc b/reactos/dll/cpl/input/lang/no-NO.rc
index c9a3d4a..5b1a030 100644
--- a/reactos/dll/cpl/input/lang/no-NO.rc
+++ b/reactos/dll/cpl/input/lang/no-NO.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Dutch"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estonian"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/pl-PL.rc b/reactos/dll/cpl/input/lang/pl-PL.rc
index b52f953..dac2f3d 100644
--- a/reactos/dll/cpl/input/lang/pl-PL.rc
+++ b/reactos/dll/cpl/input/lang/pl-PL.rc
@@ -168,6 +168,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Malediwski (Fonetyczny)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Malediwski (Maszynisty)"
     IDS_DUTCH_LAYOUT "Holenderski"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estoński"
     IDS_FAEROESE_LAYOUT "Farerski"
     IDS_FARSI_LAYOUT "Perski"
diff --git a/reactos/dll/cpl/input/lang/pt-BR.rc b/reactos/dll/cpl/input/lang/pt-BR.rc
index d492ae0..5ee3773 100644
--- a/reactos/dll/cpl/input/lang/pt-BR.rc
+++ b/reactos/dll/cpl/input/lang/pt-BR.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi fonético"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Holandês"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estoniano"
     IDS_FAEROESE_LAYOUT "Faroês"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/ro-RO.rc b/reactos/dll/cpl/input/lang/ro-RO.rc
index b870155..917fb5e 100644
--- a/reactos/dll/cpl/input/lang/ro-RO.rc
+++ b/reactos/dll/cpl/input/lang/ro-RO.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi (fonetică)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi (dactilografică)"
     IDS_DUTCH_LAYOUT "Olandeză"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estonă"
     IDS_FAEROESE_LAYOUT "Feroeză"
     IDS_FARSI_LAYOUT "Persană"
diff --git a/reactos/dll/cpl/input/lang/ru-RU.rc b/reactos/dll/cpl/input/lang/ru-RU.rc
index 72958c1..91ab283 100644
--- a/reactos/dll/cpl/input/lang/ru-RU.rc
+++ b/reactos/dll/cpl/input/lang/ru-RU.rc
@@ -160,6 +160,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Дивихай фонетическая"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Дивихай машинопись"
     IDS_DUTCH_LAYOUT "Голландская"
+    IDS_ESPERANTO_LAYOUT "Эсперанто"
     IDS_ESTONIAN_LAYOUT "Эстонская"
     IDS_FAEROESE_LAYOUT "Фарерская"
     IDS_FARSI_LAYOUT "Фарси"
diff --git a/reactos/dll/cpl/input/lang/sk-SK.rc b/reactos/dll/cpl/input/lang/sk-SK.rc
index 51064b7..5a141a5 100644
--- a/reactos/dll/cpl/input/lang/sk-SK.rc
+++ b/reactos/dll/cpl/input/lang/sk-SK.rc
@@ -165,6 +165,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Holandské"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estónske"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/sq-AL.rc b/reactos/dll/cpl/input/lang/sq-AL.rc
index 4d9253a..d94af56 100644
--- a/reactos/dll/cpl/input/lang/sq-AL.rc
+++ b/reactos/dll/cpl/input/lang/sq-AL.rc
@@ -164,6 +164,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Phonetic"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Typewriter"
     IDS_DUTCH_LAYOUT "Hollandeze"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estoni"
     IDS_FAEROESE_LAYOUT "Faeroese"
     IDS_FARSI_LAYOUT "Farsi"
diff --git a/reactos/dll/cpl/input/lang/tr-TR.rc b/reactos/dll/cpl/input/lang/tr-TR.rc
index 59c2a56..e7436ae 100644
--- a/reactos/dll/cpl/input/lang/tr-TR.rc
+++ b/reactos/dll/cpl/input/lang/tr-TR.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Divehi Tüm Seslik"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Divehi Yazı Makinesi"
     IDS_DUTCH_LAYOUT "Hollandaca"
+    IDS_ESPERANTO_LAYOUT "Esperanto"
     IDS_ESTONIAN_LAYOUT "Estçe"
     IDS_FAEROESE_LAYOUT "Faroece"
     IDS_FARSI_LAYOUT "Farsça"
diff --git a/reactos/dll/cpl/input/lang/uk-UA.rc b/reactos/dll/cpl/input/lang/uk-UA.rc
index fdfe7a2..163e375 100644
--- a/reactos/dll/cpl/input/lang/uk-UA.rc
+++ b/reactos/dll/cpl/input/lang/uk-UA.rc
@@ -168,6 +168,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "Мальдівська (фонетична)"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "Мальдівська (друкарська машинка)"
     IDS_DUTCH_LAYOUT "Нідерландська"
+    IDS_ESPERANTO_LAYOUT "Есперанто"
     IDS_ESTONIAN_LAYOUT "Естонська"
     IDS_FAEROESE_LAYOUT "Фарерська"
     IDS_FARSI_LAYOUT "Перська"
diff --git a/reactos/dll/cpl/input/lang/zh-CN.rc b/reactos/dll/cpl/input/lang/zh-CN.rc
index 5a75381..bc6afac 100644
--- a/reactos/dll/cpl/input/lang/zh-CN.rc
+++ b/reactos/dll/cpl/input/lang/zh-CN.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "第维埃语拼音"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "第维埃语印刷文字"
     IDS_DUTCH_LAYOUT "荷兰"
+    IDS_ESPERANTO_LAYOUT "世界语"
     IDS_ESTONIAN_LAYOUT "爱沙尼亚文"
     IDS_FAEROESE_LAYOUT "法罗文"
     IDS_FARSI_LAYOUT "波斯文"
diff --git a/reactos/dll/cpl/input/lang/zh-TW.rc b/reactos/dll/cpl/input/lang/zh-TW.rc
index f248dab..1c7e2f4 100644
--- a/reactos/dll/cpl/input/lang/zh-TW.rc
+++ b/reactos/dll/cpl/input/lang/zh-TW.rc
@@ -162,6 +162,7 @@ BEGIN
     IDS_DIVEHI_PHONETIC_LAYOUT "第維埃語拼音"
     IDS_DIVEHI_TYPEWRITER_LAYOUT "第維埃語印刷文字"
     IDS_DUTCH_LAYOUT "荷蘭"
+    IDS_ESPERANTO_LAYOUT "世界語"
     IDS_ESTONIAN_LAYOUT "愛沙尼亞文"
     IDS_FAEROESE_LAYOUT "法羅文"
     IDS_FARSI_LAYOUT "波斯文"
diff --git a/reactos/dll/cpl/input/resource.h b/reactos/dll/cpl/input/resource.h
index 575e359..16888a6 100644
--- a/reactos/dll/cpl/input/resource.h
+++ b/reactos/dll/cpl/input/resource.h
@@ -204,3 +204,4 @@
 #define IDS_GERMAN_DE_ERGO_LAYOUT                      5139
 #define IDS_BURMESE_LAYOUT                             5140
 #define IDS_UKRAINIAN_STUDENT_LAYOUT                   5141
+#define IDS_ESPERANTO_LAYOUT                           5142
diff --git a/reactos/dll/keyboard/CMakeLists.txt b/reactos/dll/keyboard/CMakeLists.txt
index 86afe73..26552b2 100644
--- a/reactos/dll/keyboard/CMakeLists.txt
+++ b/reactos/dll/keyboard/CMakeLists.txt
@@ -21,6 +21,7 @@ list(APPEND _keyboard_layouts
     kbdcz1
     kbdda
     kbddv
+    kbdeo
     kbdes
     kbdest
     kbdfc
diff --git a/reactos/dll/keyboard/kbdeo/kbdeo.c b/reactos/dll/keyboard/kbdeo/kbdeo.c
new file mode 100644
index 0000000..7346f58
--- /dev/null
+++ b/reactos/dll/keyboard/kbdeo/kbdeo.c
@@ -0,0 +1,410 @@
+/*
+ * ReactOS Esperanto Keyboard layout
+ * Copyright (C) 2003-2016 ReactOS
+ * License: LGPL, see: LGPL.txt
+ *
+ * Thanks to: http://www.barcodeman.com/altek/mule/scandoc.php
+ * and http://win.tue.nl/~aeb/linux/kbd/scancodes-1.html
+ *
+ * Esperanto layout recreated from the X.Org version
+ */
+
+#define WIN32_NO_STATUS
+#include <stdarg.h>
+#include <windef.h>
+#include <winuser.h>
+#include <ndk/kbd.h>
+
+#ifdef _M_IA64
+#define ROSDATA static __declspec(allocate(".data"))
+#else
+#ifdef _MSC_VER
+#pragma data_seg(".data")
+#define ROSDATA static
+#else
+#define ROSDATA static __attribute__((section(".data")))
+#endif
+#endif
+
+#define VK_EMPTY  0xff   /* The non-existent VK */
+
+#define KNUMS     KBDNUMPAD|KBDSPECIAL /* Special + number pad */
+#define KMEXT     KBDEXT|KBDMULTIVK    /* Multi + ext */
+
+ROSDATA USHORT scancode_to_vk[] = {
+  /* Numbers Row */
+  /* - 00 - */
+  /* 1 ...         2 ...         3 ...         4 ... */
+  VK_EMPTY,     VK_ESCAPE,    '1',          '2',
+  '3',          '4',          '5',          '6',
+  '7',          '8',          '9',          '0',
+  VK_OEM_MINUS, VK_OEM_PLUS,  VK_BACK,
+  /* - 0f - */
+  /* First Letters Row */
+  VK_TAB,       'Q',          'W',          'E',
+  'R',          'T',          'Y',          'U',
+  'I',          'O',          'P',
+  VK_OEM_4,     VK_OEM_6,     VK_RETURN,
+  /* - 1d - */
+  /* Second Letters Row */
+  VK_LCONTROL,
+  'A',          'S',          'D',          'F',
+  'G',          'H',          'J',          'K',
+  'L',          VK_OEM_1,     VK_OEM_7,     VK_OEM_3,
+  VK_LSHIFT,    VK_OEM_5,
+  /* - 2c - */
+  /* Third letters row */
+  'Z',          'X',          'C',          'V',
+  'B',          'N',          'M',          VK_OEM_COMMA,
+  VK_OEM_PERIOD,VK_OEM_2,     VK_RSHIFT,
+  /* - 37 - */
+  /* Bottom Row */
+  VK_MULTIPLY,  VK_LMENU,     VK_SPACE,     VK_CAPITAL,
+
+  /* - 3b - */
+  /* F-Keys */
+  VK_F1, VK_F2, VK_F3, VK_F4, VK_F5, VK_F6,
+  VK_F7, VK_F8, VK_F9, VK_F10,
+  /* - 45 - */
+  /* Locks */
+  VK_NUMLOCK | KMEXT,
+  VK_SCROLL | KBDMULTIVK,
+  /* - 47 - */
+  /* Number-Pad */
+  VK_HOME | KNUMS,      VK_UP | KNUMS,         VK_PRIOR | KNUMS, VK_SUBTRACT,
+  VK_LEFT | KNUMS,      VK_CLEAR | KNUMS,      VK_RIGHT | KNUMS, VK_ADD,
+  VK_END | KNUMS,       VK_DOWN | KNUMS,       VK_NEXT | KNUMS,
+  VK_INSERT | KNUMS,    VK_DELETE | KNUMS,
+  /* - 54 - */
+  /* Presumably PrtSc */
+  VK_SNAPSHOT,
+  /* - 55 - */
+  /* Oddities, and the remaining standard F-Keys */
+  VK_EMPTY,     VK_OEM_102,     VK_F11,       VK_F12,
+  /* - 59 - */
+  VK_CLEAR,     VK_EMPTY,     VK_EMPTY,     VK_EMPTY,     VK_EMPTY, /* EREOF */
+  VK_EMPTY,     VK_EMPTY,     VK_EMPTY,     VK_EMPTY,     VK_EMPTY, /* ZOOM */
+  VK_HELP,
+  /* - 64 - */
+  /* Even more F-Keys (for example, NCR keyboards from the early 90's) */
+  VK_F13, VK_F14, VK_F15, VK_F16, VK_F17, VK_F18, VK_F19, VK_F20,
+  VK_F21, VK_F22, VK_F23,
+  /* - 6f - */
+  /* Not sure who uses these codes */
+  VK_EMPTY, VK_EMPTY, VK_EMPTY,
+  /* - 72 - */
+  VK_EMPTY, VK_EMPTY, VK_EMPTY, VK_EMPTY,
+  /* - 76 - */
+  /* One more f-key */
+  VK_F24,
+  /* - 77 - */
+  VK_EMPTY, VK_EMPTY, VK_EMPTY, VK_EMPTY,
+  VK_EMPTY, VK_EMPTY, VK_EMPTY, VK_EMPTY, /* PA1 */
+  VK_EMPTY,
+  /* - 80 - */
+  0
+};
+
+ROSDATA VSC_VK extcode0_to_vk[] = {
+  { 0x10, VK_MEDIA_PREV_TRACK | KBDEXT },
+  { 0x19, VK_MEDIA_NEXT_TRACK | KBDEXT },
+  { 0x1D, VK_RCONTROL | KBDEXT },
+  { 0x20, VK_VOLUME_MUTE | KBDEXT },
+  { 0x21, VK_LAUNCH_APP2 | KBDEXT },
+  { 0x22, VK_MEDIA_PLAY_PAUSE | KBDEXT },
+  { 0x24, VK_MEDIA_STOP | KBDEXT },
+  { 0x2E, VK_VOLUME_DOWN | KBDEXT },
+  { 0x30, VK_VOLUME_UP | KBDEXT },
+  { 0x32, VK_BROWSER_HOME | KBDEXT },
+  { 0x35, VK_DIVIDE | KBDEXT },
+  { 0x37, VK_SNAPSHOT | KBDEXT },
+  { 0x38, VK_RMENU | KBDEXT },
+  { 0x47, VK_HOME | KBDEXT },
+  { 0x48, VK_UP | KBDEXT },
+  { 0x49, VK_PRIOR | KBDEXT },
+  { 0x4B, VK_LEFT | KBDEXT },
+  { 0x4D, VK_RIGHT | KBDEXT },
+  { 0x4F, VK_END | KBDEXT },
+  { 0x50, VK_DOWN | KBDEXT },
+  { 0x51, VK_NEXT | KBDEXT },
+  { 0x52, VK_INSERT | KBDEXT },
+  { 0x53, VK_DELETE | KBDEXT },
+  { 0x5B, VK_LWIN | KBDEXT },
+  { 0x5C, VK_RWIN | KBDEXT },
+  { 0x5D, VK_APPS | KBDEXT },
+  { 0x5F, VK_SLEEP | KBDEXT },
+  { 0x65, VK_BROWSER_SEARCH | KBDEXT },
+  { 0x66, VK_BROWSER_FAVORITES | KBDEXT },
+  { 0x67, VK_BROWSER_REFRESH | KBDEXT },
+  { 0x68, VK_BROWSER_STOP | KBDEXT },
+  { 0x69, VK_BROWSER_FORWARD | KBDEXT },
+  { 0x6A, VK_BROWSER_BACK | KBDEXT },
+  { 0x6B, VK_LAUNCH_APP1 | KBDEXT },
+  { 0x6C, VK_LAUNCH_MAIL | KBDEXT },
+  { 0x6D, VK_LAUNCH_MEDIA_SELECT | KBDEXT },
+  { 0x1C, VK_RETURN | KBDEXT },
+  { 0x46, VK_CANCEL | KBDEXT },
+  { 0, 0 },
+};
+
+ROSDATA VSC_VK extcode1_to_vk[] = {
+  { 0x1d, VK_PAUSE },
+  { 0, 0 },
+};
+
+ROSDATA VK_TO_BIT modifier_keys[] = {
+  { VK_SHIFT,   KBDSHIFT },
+  { VK_CONTROL, KBDCTRL },
+  { VK_MENU,    KBDALT },
+  { 0,          0 }
+};
+
+ROSDATA MODIFIERS modifier_bits = {
+  modifier_keys,
+  7,
+  {
+      0,            // NONE
+      1,            // SHIFT
+      2,            // CTRL
+      3,            // SHIFT+CTRL
+      0,            // ALT (not used)
+      0,            // SHIFT-ALT (not used)
+      4,            // CTRL-ALT
+      5,            // SHIFT-CTRL-ALT
+  }
+};
+
+ROSDATA VK_TO_WCHARS2 key_to_chars_2mod[] = {
+  /* Normal vs Shifted */
+  /* The alphabet */
+  { 'B',         CAPLOK,   {'b', 'B'} },
+  { 'C',         CAPLOK,   {'c', 'C'} },
+  { 'E',         CAPLOK,   {'e', 'E'} },
+  { 'G',         CAPLOK,   {'g', 'G'} },
+  { 'H',         CAPLOK,   {'h', 'H'} },
+  { 'I',         CAPLOK,   {'i', 'I'} },
+  { 'J',         CAPLOK,   {'j', 'J'} },
+  { 'K',         CAPLOK,   {'k', 'K'} },
+  { 'L',         CAPLOK,   {'l', 'L'} },
+  { 'R',         CAPLOK,   {'r', 'R'} },
+  { 'T',         CAPLOK,   {'t', 'T'} },
+  { 'U',         CAPLOK,   {'u', 'U'} },
+  { 'V',         CAPLOK,   {'v', 'V'} },
+  { 'Z',         CAPLOK,   {'z', 'Z'} },
+  /* The numbers */
+  { '1',         0, {'1', '!'} },
+  { '3',         0, {'3', '#'} },
+  { '7',         0, {'7', '&'} },
+  { '8',         0, {'8', '*'} },
+  { '9',         0, {'9', '('} },
+  { '0',         0, {'0', ')'} },
+
+  /* Specials */
+  /* Ctrl-_ generates US */
+  { VK_OEM_PLUS,   0, {'=', '+'} },
+  { VK_OEM_1,      0, {';', ':'} },
+  { VK_OEM_7,      0, {'\'','\"'} },
+  { VK_OEM_3,      0, {'`', '~'} },
+  { VK_OEM_COMMA,  0, {',', '<'} },
+  { VK_OEM_PERIOD, 0, {'.', '>'} },
+  { VK_OEM_2,      0, {'/', '?'} },
+  /* Keys that do not have shift states */
+  { VK_TAB,      0, {'\t','\t'} },
+  { VK_ADD,      0, {'+', '+'} },
+  { VK_SUBTRACT, 0, {'-', '-'} },
+  { VK_DECIMAL,  0, {'.', '.'} },
+  { VK_MULTIPLY, 0, {'*', '*'} },
+  { VK_DIVIDE,   0, {'/', '/'} },
+  { 0, 0 }
+};
+
+ROSDATA VK_TO_WCHARS3 key_to_chars_3mod[] = {
+  /* Normal, Shifted, Ctrl */
+  /* Legacy (telnet-style) ascii escapes */
+  { VK_OEM_5,   0, {'\\','|', 0x1c /* FS */} },
+  { VK_OEM_102, 0, {'\\','|', 0x1c /* FS */} },
+  { VK_BACK,    0, {0x8, 0x8, 0x7F } },
+  { VK_ESCAPE,  0, {0x1b,0x1b,0x1b } },
+  { VK_RETURN,  0, {'\r','\r','\n'} },
+  { VK_SPACE,   0, {' ', ' ', ' '} },
+  { VK_CANCEL,  0, {0x3, 0x3, 0x3} },
+  { 0, 0 }
+};
+
+ROSDATA VK_TO_WCHARS4 key_to_chars_4mod[] = {
+  /* Normal, Shifted, Ctrl, C-S-x */
+  /* Legacy Ascii generators */
+  { '2',          0, {'2', '@', WCH_NONE, 0} },
+  { '6',          0, {'6', '^', WCH_NONE, 0x1e /* RS */} },
+  { VK_OEM_MINUS, 0, {'-', '_', WCH_NONE, 0x1f /* US */} },
+  { 0, 0 }
+};
+
+ROSDATA VK_TO_WCHARS5 key_to_chars_5mod[] = {
+  /* Normal, Shifted, Ctrl, C-S-x, AltGr */
+  { 'A', 1, {'a', 'A', WCH_NONE, WCH_NONE, 0x2018 /* ‘ */ } },
+  { 'S', 1, {'s', 'S', WCH_NONE, WCH_NONE, 0x2019 /* ’ */ } },
+  { 'D', 1, {'d', 'D', WCH_NONE, WCH_NONE, 0x201c /* “ */ } },
+  { 'F', 1, {'f', 'F', WCH_NONE, WCH_NONE, 0x201d /* ” */ } },
+  { 'M', 1, {'m', 'M', WCH_NONE, WCH_NONE, 0x2014 /* — */ } },
+  { 'N', 1, {'n', 'N', WCH_NONE, WCH_NONE, 0x2013 /* – */ } },
+  { 'O', 1, {'o', 'O', WCH_NONE, WCH_NONE, '{' } },
+  { 'P', 1, {'p', 'P', WCH_NONE, WCH_NONE, '}' } },
+  { '5', 0, {'5', '%', WCH_NONE, WCH_NONE, 0x20ac /* € */ } },
+  { 0, 0 }
+};
+
+ROSDATA VK_TO_WCHARS6 key_to_chars_6mod[] = {
+  /* Normal, Shifted, Ctrl, C-S-x, AltGr, Shift-AltGr */
+  { 'Q',      5, {0x015d, 0x015c, WCH_NONE, WCH_NONE, 'q', 'Q' /* ŝŜ */ } },
+  { 'W',      5, {0x011d, 0x011c, WCH_NONE, WCH_NONE, 'w', 'W' /* ĝĜ */ } },
+  { 'X',      5, {0x0109, 0x0108, WCH_NONE, WCH_NONE, 'x', 'X' /* ĉĈ */ } },
+  { 'Y',      5, {0x016d, 0x016c, WCH_NONE, WCH_NONE, 'y', 'Y' /* ŭŬ */ } },
+  { VK_OEM_4, 1, {0x0135, 0x0134, 0x1b, WCH_NONE, '[', '{', /* ĵĴ, ESC */ } },
+  { VK_OEM_6, 1, {0x0125, 0x0124, 0x1d, WCH_NONE, ']', '}', /* ĥĤ, GS */ } },
+  { 0, 0 }
+};
+
+ROSDATA VK_TO_WCHARS1 keypad_numbers[] = {
+  { VK_NUMPAD0, 0, {'0'} },
+  { VK_NUMPAD1, 0, {'1'} },
+  { VK_NUMPAD2, 0, {'2'} },
+  { VK_NUMPAD3, 0, {'3'} },
+  { VK_NUMPAD4, 0, {'4'} },
+  { VK_NUMPAD5, 0, {'5'} },
+  { VK_NUMPAD6, 0, {'6'} },
+  { VK_NUMPAD7, 0, {'7'} },
+  { VK_NUMPAD8, 0, {'8'} },
+  { VK_NUMPAD9, 0, {'9'} },
+  { 0, 0 }
+};
+
+#define vk_master(n, x) { (PVK_TO_WCHARS1)x, n, sizeof(x[0]) }
+
+ROSDATA VK_TO_WCHAR_TABLE vk_to_wchar_master_table[] = {
+  vk_master(1, keypad_numbers),
+  vk_master(2, key_to_chars_2mod),
+  vk_master(3, key_to_chars_3mod),
+  vk_master(4, key_to_chars_4mod),
+  vk_master(5, key_to_chars_5mod),
+  vk_master(6, key_to_chars_6mod),
+  { 0, 0, 0 }
+};
+
+ROSDATA VSC_LPWSTR key_names[] = {
+  { 0x01, L"Eskapklavo" },
+  { 0x0e, L"Retropaŝo" },
+  { 0x0f, L"Tabo" },
+  { 0x1c, L"Tirilo" },
+  { 0x1d, L"Stirklavo" },
+  { 0x2a, L"Majuskliga" },
+  { 0x36, L"Dekstra majuskliga" },
+  { 0x37, L"Nom *" },
+  { 0x38, L"Alt" },
+  { 0x39, L"Spaco" },
+  { 0x3a, L"Majusklo ŝlosi" },
+  { 0x3b, L"F1" },
+  { 0x3c, L"F2" },
+  { 0x3d, L"F3" },
+  { 0x3e, L"F4" },
+  { 0x3f, L"F5" },
+  { 0x40, L"F6" },
+  { 0x41, L"F7" },
+  { 0x42, L"F8" },
+  { 0x43, L"F9" },
+  { 0x44, L"F10" },
+  { 0x45, L"Paŭzo" },
+  { 0x46, L"Rulumi ŝlosi" },
+  { 0x47, L"Nom 7" },
+  { 0x48, L"Nom 8" },
+  { 0x49, L"Nom 9" },
+  { 0x4a, L"Nom -" },
+  { 0x4b, L"Nom 4" },
+  { 0x4c, L"Nom 5" },
+  { 0x4d, L"Nom 6" },
+  { 0x4e, L"Nom +" },
+  { 0x4f, L"Nom 1" },
+  { 0x50, L"Nom 2" },
+  { 0x51, L"Nom 3" },
+  { 0x52, L"Nom 0" },
+  { 0x53, L"Nom forviŝi" },
+  { 0x54, L"Sistemo peto" },
+  { 0x56, L"\\" },
+  { 0x57, L"F11" },
+  { 0x58, L"F12" },
+  { 0x7c, L"F13" },
+  { 0x7d, L"F14" },
+  { 0x7e, L"F15" },
+  { 0x7f, L"F16" },
+  { 0x80, L"F17" },
+  { 0x81, L"F18" },
+  { 0x82, L"F19" },
+  { 0x83, L"F20" },
+  { 0x84, L"F21" },
+  { 0x85, L"F22" },
+  { 0x86, L"F23" },
+  { 0x87, L"F24" },
+  { 0, NULL },
+};
+
+ROSDATA VSC_LPWSTR extended_key_names[] = {
+  { 0x1c, L"Nom Tirilo" },
+  { 0x1d, L"Dekstra Stirklavo" },
+  { 0x35, L"Nom /" },
+  { 0x37, L"Presi Ekrano" },
+  { 0x38, L"Dekstra Alt" },
+  { 0x45, L"Nom Ŝlosi" },
+  { 0x46, L"Paŭzi" },
+  { 0x47, L"Hejmo" },
+  { 0x48, L"Supren" },
+  { 0x49, L"Paĝo Supren" },
+  { 0x4a, L"-" },
+  { 0x4b, L"Maldekstra" },
+  { 0x4d, L"Dekstra" },
+  { 0x4f, L"Fino" },
+  { 0x50, L"Doĝn" },
+  { 0x51, L"Paĝo Doĝn" },
+  { 0x52, L"Enigaĵo" },
+  { 0x53, L"Forviŝi" },
+  { 0x54, L"<00>" },
+  { 0x56, L"Helpo" },
+  { 0x5b, L"Maldesktra Windows" },
+  { 0x5c, L"Desktra Windows" },
+  { 0x5d, L"Apliko" },
+  { 0, NULL },
+};
+
+/* Finally, the master table */
+ROSDATA KBDTABLES keyboard_layout_table = {
+  /* modifier assignments */
+  &modifier_bits,
+
+  /* character from vk tables */
+  vk_to_wchar_master_table,
+
+  /* diacritical marks -- currently implemented by wine code */
+  /* Esperanto doesn't have any, anyway */
+  NULL,
+
+  /* Key names */
+  (VSC_LPWSTR *)key_names,
+  (VSC_LPWSTR *)extended_key_names,
+  NULL, /* Dead key names */
+
+  /* scan code to virtual key maps */
+  scancode_to_vk,
+  sizeof(scancode_to_vk) / sizeof(scancode_to_vk[0]),
+  extcode0_to_vk,
+  extcode1_to_vk,
+
+  MAKELONG(KLLF_ALTGR, 1), /* Version 1.0 */
+
+  /* Ligatures -- Esperanto doesn't have any */
+  0,
+  0,
+  NULL
+};
+
+PKBDTABLES WINAPI KbdLayerDescriptor(VOID) {
+  return &keyboard_layout_table;
+}
diff --git a/reactos/dll/keyboard/kbdeo/kbdeo.rc b/reactos/dll/keyboard/kbdeo/kbdeo.rc
new file mode 100644
index 0000000..d1ab5fb
--- /dev/null
+++ b/reactos/dll/keyboard/kbdeo/kbdeo.rc
@@ -0,0 +1,5 @@
+#define REACTOS_VERSION_DLL
+#define REACTOS_STR_FILE_DESCRIPTION  "ReactOS Esperanto Keyboard Layout"
+#define REACTOS_STR_INTERNAL_NAME     "kbdeo"
+#define REACTOS_STR_ORIGINAL_FILENAME "kbdeo.dll"
+#include <reactos/version.rc>
diff --git a/reactos/dll/keyboard/kbdeo/kbdeo.spec b/reactos/dll/keyboard/kbdeo/kbdeo.spec
new file mode 100644
index 0000000..e1c7a26
--- /dev/null
+++ b/reactos/dll/keyboard/kbdeo/kbdeo.spec
@@ -0,0 +1 @@
+@ stdcall KbdLayerDescriptor()
\ No newline at end of file
diff --git a/reactos/dll/win32/kernel32/winnls/locale_rc.rc b/reactos/dll/win32/kernel32/winnls/locale_rc.rc
index 2c1ceca..96a3384 100644
--- a/reactos/dll/win32/kernel32/winnls/locale_rc.rc
+++ b/reactos/dll/win32/kernel32/winnls/locale_rc.rc
@@ -125,6 +125,9 @@
 #include "nls/enp.nls"   /* 0x3409  LANG_ENGLISH, SUBLANG_ENGLISH_PHILIPPINES */
 
 #pragma code_page(1252)
+#include "nls/eoa.nls"   /* 0x048F  LANG_ESPERANTO, SUBLANG_ESPERANTO */
+
+#pragma code_page(1252)
 #include "nls/esp.nls"   /* 0x040a  LANG_SPANISH, SUBLANG_SPANISH */
 #pragma code_page(1252)
 #include "nls/esm.nls"   /* 0x080a  LANG_SPANISH, SUBLANG_SPANISH_MEXICAN */
diff --git a/reactos/dll/win32/kernel32/winnls/nls/eoa.nls b/reactos/dll/win32/kernel32/winnls/nls/eoa.nls
new file mode 100644
index 0000000..0f12446
--- /dev/null
+++ b/reactos/dll/win32/kernel32/winnls/nls/eoa.nls
@@ -0,0 +1,159 @@
+/*
+ * Locale definitions for Esperanto
+ *
+ * Copyright 2002 Alexandre Julliard for CodeWeavers
+ * Copyright 2016 ReactOS Contributors
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#pragma code_page(1252)
+
+STRINGTABLE LANGUAGE LANG_ESPERANTO, SUBLANG_DEFAULT
+{
+  LOCALE_FONTSIGNATURE L"\x002f\x8000\x3808\x0000\x0000\x0000\x0000\x0000\x0003\x0000\x0000\x4000\x01ff\x003f\x8000\xffff"
+  LOCALE_ICALENDARTYPE "1"
+  LOCALE_ICENTURY "1"
+  LOCALE_ICOUNTRY "0"
+  LOCALE_ICURRDIGITS "2"
+  LOCALE_ICURRENCY "0"
+  LOCALE_IDATE "1"
+  LOCALE_IDAYLZERO "1"
+  LOCALE_IDEFAULTANSICODEPAGE "28593"
+  LOCALE_IDEFAULTCODEPAGE "437"
+  LOCALE_IDEFAULTCOUNTRY "0"
+  LOCALE_IDEFAULTEBCDICCODEPAGE "037"
+  LOCALE_IDEFAULTLANGUAGE "048F"
+  LOCALE_IDEFAULTMACCODEPAGE "10000"
+  LOCALE_IDEFAULTUNIXCODEPAGE "28593"
+  LOCALE_IDIGITS "2"
+  LOCALE_IDIGITSUBSTITUTION "1"
+  LOCALE_IFIRSTDAYOFWEEK "0"
+  LOCALE_IFIRSTWEEKOFYEAR "0"
+  LOCALE_IINTLCURRDIGITS "2"
+  LOCALE_ILANGUAGE "048F"
+  LOCALE_ILDATE "1"
+  LOCALE_ILZERO "1"
+  LOCALE_IMEASURE "0"
+  LOCALE_IMONLZERO "1"
+  LOCALE_INEGCURR "1"
+  LOCALE_INEGNUMBER "1"
+  LOCALE_INEGSEPBYSPACE "0"
+  LOCALE_INEGSIGNPOSN "3"
+  LOCALE_INEGSYMPRECEDES "1"
+  LOCALE_INEUTRAL "0"
+  LOCALE_IOPTIONALCALENDAR "0"
+  LOCALE_IPAPERSIZE "9"
+  LOCALE_IPOSSEPBYSPACE "0"
+  LOCALE_IPOSSIGNPOSN "3"
+  LOCALE_IPOSSYMPRECEDES "1"
+  LOCALE_IREADINGLAYOUT "0"
+  LOCALE_ITIME "1"
+  LOCALE_ITIMEMARKPOSN "0"
+  LOCALE_ITLZERO "1"
+  LOCALE_S1159 "AM"
+  LOCALE_S2359 "PM"
+  LOCALE_SABBREVCTRYNAME ""
+  LOCALE_SABBREVDAYNAME1 "lun"
+  LOCALE_SABBREVDAYNAME2 "mar"
+  LOCALE_SABBREVDAYNAME3 "mer"
+  LOCALE_SABBREVDAYNAME4 "\274au"
+  LOCALE_SABBREVDAYNAME5 "ven"
+  LOCALE_SABBREVDAYNAME6 "sab"
+  LOCALE_SABBREVDAYNAME7 "dim"
+  LOCALE_SABBREVLANGNAME "EO"
+  LOCALE_SABBREVMONTHNAME1 "jan"
+  LOCALE_SABBREVMONTHNAME2 "feb"
+  LOCALE_SABBREVMONTHNAME3 "mar"
+  LOCALE_SABBREVMONTHNAME4 "apr"
+  LOCALE_SABBREVMONTHNAME5 "maj"
+  LOCALE_SABBREVMONTHNAME6 "jun"
+  LOCALE_SABBREVMONTHNAME7 "jul"
+  LOCALE_SABBREVMONTHNAME8 "au\370"
+  LOCALE_SABBREVMONTHNAME9 "sep"
+  LOCALE_SABBREVMONTHNAME10 "okt"
+  LOCALE_SABBREVMONTHNAME11 "nov"
+  LOCALE_SABBREVMONTHNAME12 "dec"
+  LOCALE_SABBREVMONTHNAME13 ""
+  LOCALE_SCOUNTRY ""
+  LOCALE_SCURRENCY "\244"
+  LOCALE_SDATE "/"
+  LOCALE_SDAYNAME1 "lundo"
+  LOCALE_SDAYNAME2 "mardo"
+  LOCALE_SDAYNAME3 "merkredo"
+  LOCALE_SDAYNAME4 "\274a\375do"
+  LOCALE_SDAYNAME5 "vendredo"
+  LOCALE_SDAYNAME6 "sabato"
+  LOCALE_SDAYNAME7 "diman\346o"
+  LOCALE_SDECIMAL "."
+  LOCALE_SENGCOUNTRY ""
+  LOCALE_SENGCURRNAME ""
+  LOCALE_SENGLANGUAGE "Esperanto"
+  LOCALE_SGROUPING "3;0"
+  LOCALE_SINTLSYMBOL ""
+  LOCALE_SISO3166CTRYNAME ""
+  LOCALE_SISO639LANGNAME "eo"
+  LOCALE_SLANGUAGE "Esperanto"
+  LOCALE_SLIST ","
+  LOCALE_SLONGDATE "dddd, dd MMMM, yyyy"
+  LOCALE_SMONDECIMALSEP "."
+  LOCALE_SMONGROUPING "3;0"
+  LOCALE_SMONTHNAME1 "januaro"
+  LOCALE_SMONTHNAME2 "februaro"
+  LOCALE_SMONTHNAME3 "marto"
+  LOCALE_SMONTHNAME4 "aprilo"
+  LOCALE_SMONTHNAME5 "majo"
+  LOCALE_SMONTHNAME6 "junio"
+  LOCALE_SMONTHNAME7 "julio"
+  LOCALE_SMONTHNAME8 "a\375gusto"
+  LOCALE_SMONTHNAME9 "septembro"
+  LOCALE_SMONTHNAME10 "oktobro"
+  LOCALE_SMONTHNAME11 "novembro"
+  LOCALE_SMONTHNAME12 "decembro"
+  LOCALE_SMONTHNAME13 ""
+  LOCALE_SMONTHOUSANDSEP ","
+  LOCALE_SNAME "eo-AA"
+  LOCALE_SNATIVECTRYNAME ""
+  LOCALE_SNATIVECURRNAME ""
+  LOCALE_SNATIVEDIGITS "0123456789"
+  LOCALE_SNATIVELANGNAME "Esperanto"
+  LOCALE_SNEGATIVESIGN "-"
+  LOCALE_SPOSITIVESIGN ""
+  LOCALE_SSCRIPTS "Latn;"
+  LOCALE_SSHORTDATE "dd/MM/yyyy"
+  LOCALE_SSORTNAME "Default"
+  LOCALE_STHOUSAND ","
+  LOCALE_STIME ":"
+  LOCALE_STIMEFORMAT "HH:mm:ss"
+  LOCALE_SYEARMONTH "MMMM yyyy"
+
+  LGRPID_WESTERN_EUROPE+LGRPID_RES_BASE "Okcidenta e\375ropo kaj Usono"
+  LGRPID_CENTRAL_EUROPE+LGRPID_RES_BASE "Centra e\375ropo"
+  LGRPID_BALTIC+LGRPID_RES_BASE "Balta"
+  LGRPID_GREEK+LGRPID_RES_BASE "Greka"
+  LGRPID_CYRILLIC+LGRPID_RES_BASE "Cirila"
+  LGRPID_TURKISH+LGRPID_RES_BASE "Turklingva"
+  LGRPID_JAPANESE+LGRPID_RES_BASE "Japenese"
+  LGRPID_KOREAN+LGRPID_RES_BASE "Korea"
+  LGRPID_TRADITIONAL_CHINESE+LGRPID_RES_BASE "Tradicia \346ino"
+  LGRPID_SIMPLIFIED_CHINESE+LGRPID_RES_BASE "Simpligita \346ino"
+  LGRPID_THAI+LGRPID_RES_BASE "Taja"
+  LGRPID_HEBREW+LGRPID_RES_BASE "Hebrea"
+  LGRPID_ARABIC+LGRPID_RES_BASE "Araba"
+  LGRPID_VIETNAMESE+LGRPID_RES_BASE "Vjetnama"
+  LGRPID_INDIC+LGRPID_RES_BASE "Hindiaj"
+  LGRPID_GEORGIAN+LGRPID_RES_BASE "Georgian"
+  LGRPID_ARMENIAN+LGRPID_RES_BASE "Armenian"
+}
diff --git a/reactos/media/inf/intl.inf b/reactos/media/inf/intl.inf
index 3c521cd..d4ee845 100644
--- a/reactos/media/inf/intl.inf
+++ b/reactos/media/inf/intl.inf
@@ -60,6 +60,7 @@ DriverVer = 05/29/2008,0.1
 00002c09 = "English (Trinidad)",    850, 1,,  2c09:00000409
 00003009 = "English (Zimbabwe)",    437, 1,,  3009:00000409
 00003409 = "English (Philippines)", 437, 1,,  3409:00000409
+0000048f = "Esperanto",           28593, 1,,  048f:0000048f
 00000425 = "Estonian",              775, 3,,  0425:00000425
 00000438 = "Faeroese",              850, 1,,  0438:00000406,0409:00000409
 00000429 = "Farsi",                 720, 11,, 0409:00000409,0429:00000429,0429:00000401
diff --git a/reactos/sdk/tools/rgenstat/module_list.txt b/reactos/sdk/tools/rgenstat/module_list.txt
index 269ab99..2596dc9 100644
--- a/reactos/sdk/tools/rgenstat/module_list.txt
+++ b/reactos/sdk/tools/rgenstat/module_list.txt
@@ -23,6 +23,7 @@ dsound dll\directx\dsound
 dxdiagn dll\directx\dxdiagn
 kbdda dll\keyboard\kbdda
 kbddv dll\keyboard\kbddv
+kbdeo dll\keyboard\kbdeo
 kbdes dll\keyboard\kbdes
 kbdfr dll\keyboard\kbdfr
 kbdgr dll\keyboard\kbdgr
